#include <pic.h>

__CONFIG(WDTDIS & XT & UNPROTECT & BORDIS & MCLRIO & LVPDIS);
__EEPROM_DATA(0,0,0,0, 5,5,5,3);
__EEPROM_DATA(5,5,5,3, 0,1,0,0);
__EEPROM_DATA(1,0,0,0, 0,0,2,1);
//__EEPROM_DATA(5,5,5,5, 98,12,98,4);
__EEPROM_DATA(5,5,5,5, 0xF4,1,0x40,6);
__EEPROM_DATA(10,0,0,0, 0,0,0,0);

/*-------------------------------------------------------------------------------------------*/
//int wrkStatus; //  
static volatile bit flBtn0;
static volatile bit flBtnMode;
static volatile bit flBtnInc;
static volatile bit flBtnSet;

static volatile bit fl125Hz;
static volatile bit flSec;
static volatile bit flReadTempr;
static volatile bit flCompTempr;
static volatile bit flSetMode;
static volatile bit flTUNE_Mode;
static volatile bit flSoundOn;
/*-------------------------------------------------------------------------------------------*/
unsigned char wrkPower; //  
unsigned char wrkMode; //  
unsigned char wrkDig;
unsigned char wrkSetDig;
unsigned char wrkBtnIndx;
unsigned char wrkLTmr;
unsigned char wrkHTmr;

unsigned char wrkDel_1Hz;
unsigned int wrkZoom; //    
unsigned int wrkOfst; //    

unsigned char tmpDrvTo1Min;
unsigned char tmpDrvPause1;
unsigned char tmpDrvPause10;
unsigned char tmpDrvPause100;
unsigned char tmpDrvWork1;
unsigned char tmpDrvWork10;
unsigned char tmpDrvWork100;

unsigned char wrkTo1Min;

unsigned char tmpCmpCount;
unsigned char wrkCmpCount; 

unsigned char wrkLTmpr;
unsigned char wrkHTmpr;
unsigned long wrkTmpr;
unsigned long wrkLastTmpr;
unsigned char wrkReadTemprState;
unsigned char wrkReadTemprStateCount;

unsigned long tmpCmpVal1;
unsigned long tmpCmpVal2;
/*-------------------------------------------------------------------------------------------*/
#define MODE_TEMPR 0
#define MODE_LBOUND 4
#define MODE_HBOUND 8
#define MODE_DRVTIME 12
#define MODE_DRVPAUSE 16

#define TMPR_01 0x0
#define TMPR_1 0x1
#define TMPR_10 0x2
#define TMPR_100 0x3
#define TMPR_L_01 0x4
#define TMPR_L_1 0x5
#define TMPR_L_10 0x6
#define TMPR_L_100 0x7
#define TMPR_H_01 0x8
#define TMPR_H_1 0x9
#define TMPR_H_10 0xA
#define TMPR_H_100 0xB
#define DRV_WORK_1 0xC
#define DRV_WORK_10 0xD
#define DRV_WORK_100 0xE
#define DRV_PAUSE_1 0x10
#define DRV_PAUSE_10 0x11
#define DRV_PAUSE_100 0x12
#define CLOCK_Min1 0x14
#define CLOCK_Min10 0x15
#define CLOCK_Hour1 0x16
#define CLOCK_Hour10 0x17
#define CLOCK_ALARM_1 0x18
#define CLOCK_ALARM_10 0x19
#define CLOCK_ALARM_100 0x1A
#define CLOCK_ALARM_1000 0x1B
/*-------------------------------------------------------------------------------------------*/
unsigned char Data_Tempr[28];

const unsigned char IntTo7LCD[16] = 
{// EDGCFAB:
  0b11011110, // 0
  0b00010010, // 1
  0b11100110, // 2
  0b01110110, // 3
  0b00111010, // 4
  0b01111100, // 5
  0b11111100, // 6
  0b00010110, // 7
  0b11111110, // 8
  0b01111110, // 9
 // EDGCFAB:
  0b10000000, // - 10
  0b10000000, // - 11
  0b00101010, // pinLight=0 + pinDriver=0 12
  0b01101010, // pinLight=0 + pinDriver=1 13
  0b00001110, // pinLight=1 + pinDriver=0 14
  0b01001110  // pinLight=1 + pinDriver=1 15
};
/*-------------------------------------------------------------------------------------------*/
static volatile bit pinLight @ (unsigned)&PORTA*8+0;
static volatile bit pinDriver @ (unsigned)&PORTA*8+3;

static volatile bit pinSound @ (unsigned)&PORTB*8+0;

static volatile bit pinDCSt @ (unsigned)&PORTB*8+3;
static volatile bit pinDCDat @ (unsigned)&PORTB*8+2;
static volatile bit pinDCClk @ (unsigned)&PORTB*8+1;

static volatile bit pinLCD1 @ (unsigned)&PORTB*8+4;
static volatile bit pinLCD10 @ (unsigned)&PORTB*8+5;
static volatile bit pinLCD100 @ (unsigned)&PORTB*8+7;
static volatile bit pinLCD1000 @ (unsigned)&PORTA*8+4;

//static volatile bit pinBtns @ (unsigned)&PORTA*8+5;
static volatile bit pinBtns @ (unsigned)&PORTA*8+5;

#define RP0 0x5
#define STATUS 0x3
#define Z 0x2
#define C 0x0
#define pin1Wire RB6
#define pin1Wire_TRIS TRISB6
/*-------------------------------------------------------------------------------------------*/
void Read_Btns(void);
void Init_CPU(void);
void Out_Digit(void);
void Out_Sound(void);
void Read_Tempr(void);
void Compare_Tempr(void);
void Inc_Clock(void);
void Carry_Clock(void);
void Compare_Alarm(void);
void Inc_Timer(void);

void Read_Btns_TUNE(void);

void __IntTo4Dec(int Value, unsigned char *Digits, char Dec001);
int __Dec4ToInt(unsigned char *Digits);
/*-------------------------------------------------------------------------------------------*/
static void interrupt Interupt_Handler(void)
{
  if (T0IF)
  {
    //   ()
    pinLight = 1;
    T0IF = 0;
    asm("nop");
    asm("nop");
    asm("nop");
    asm("nop");
    asm("nop");
    asm("nop");
    asm("nop");
    asm("nop");
    asm("nop");
    asm("nop");
    asm("nop");
    asm("nop");
    asm("nop");
    asm("nop");
    asm("nop");
    asm("nop");
    pinLight = 0;
  } else
  if (CMIF)
  {
    //  
    CMCON = CMCON;
    CMIF = 0;
    TMR0 = 87 + wrkPower;
//    pinLight = 1;
  } else
  if (TMR2IF)
  {
    //  TMR2 ( )
    TMR2IF = 0;
    wrkDel_1Hz++;
  
    if (wrkDel_1Hz == 250)
    {
      wrkDel_1Hz = 0;
      flSec = 1;
      flCompTempr = 1;
    } 
    fl125Hz = 1;
    flReadTempr = 1;
  }

}
/*-------------  DS18b20------------------------------------------------*/
/*-----   1-Wire----------------------------------------------------*/
void _1w_pin_hi()
{
  pin1Wire_TRIS = 1;
}
void _1w_pin_low()
{
  pin1Wire = 0;
  pin1Wire_TRIS = 0;
}
void _1w_strong_pull_up()	// bring DQ to strong +5VDC
{
  pin1Wire = 1;
  pin1Wire_TRIS = 0;
//  pin1Wire_TRIS = 1;
}
/*-----  -----------------------------------------------------------*/
void delay_10us(unsigned char t)
{ //     byte -    W
  unsigned char t_;
  t_ = t;
  #asm
      BCF _STATUS,RP0
      DELAY_10US_1:
      CLRWDT
      NOP
      NOP
      NOP
      NOP
      NOP
      NOP
      DECFSZ (?a_delay_10us+0), F
      GOTO DELAY_10US_1
  #endasm
}
/*-----  1-Wire---------------------------------------------------------*/
void _1w_init()
{
  _1w_pin_hi();
  _1w_pin_low();
  delay_10us(50);

  _1w_pin_hi();
  delay_10us(50);
}
unsigned char _1w_in_byte()
{
  unsigned char n, i_byte;
  for (n=0; n<8; n++)
  {
    pin1Wire=0;
    pin1Wire_TRIS=0;
    pin1Wire_TRIS=1;
    #asm
      CLRWDT
      NOP
      NOP
    #endasm
    i_byte=i_byte;
    if (pin1Wire)
    {
      i_byte=(i_byte>>1) | 0x80;	// least sig bit first
    }
    else
    {
      i_byte=i_byte >> 1;
    }
    delay_10us(6);
  }
  return(i_byte);
}
void _1w_out_byte(unsigned char d)
{
  unsigned char n;
  for(n=0; n<8; n++)
  {
    if (d&0x01)
    {
      pin1Wire=0;
      pin1Wire_TRIS=0;		// momentary low
      pin1Wire_TRIS=1;
      delay_10us(6);
    }

    else
    {
      pin1Wire=0;
      pin1Wire_TRIS=0;
	  delay_10us(6);
      pin1Wire_TRIS=1;
    }
    d=d>>1;
  }
}
/*---------     DS18b20------------------------------------*/
// 1-Wire  RB6 !!!
void Read_Tempr(void)
{
  flReadTempr = 0;
  //   4 
  wrkReadTemprStateCount++;
  if (wrkReadTemprStateCount != 0x2) return;
  wrkReadTemprStateCount = 0;
  //    
  if (flSetMode) return;
  //  
  if (wrkReadTemprState == 0) _1w_init(); else
  if (wrkReadTemprState == 1)  _1w_out_byte(0xcc); else// skip ROM

  if (wrkReadTemprState == 2) _1w_out_byte(0xbe); else // read
  if (wrkReadTemprState == 3)  wrkLTmpr = _1w_in_byte(); else
  if (wrkReadTemprState == 4)  wrkHTmpr = _1w_in_byte(); else

  //   
  if (wrkReadTemprState == 5) _1w_init(); else
  if (wrkReadTemprState == 6)  _1w_out_byte(0xcc); else  // skip ROM

  if (wrkReadTemprState == 7)
  {
    _1w_out_byte(0x44);  // perform temperature conversion
    _1w_strong_pull_up();
  } else

  //  
  if (wrkReadTemprState == 8) 
  {
    wrkTmpr = (wrkLTmpr | (wrkHTmpr<<8));
    wrkTmpr = wrkZoom * wrkTmpr;
    wrkTmpr = wrkTmpr >> 8;
    wrkTmpr = wrkTmpr + 500;
    wrkTmpr = wrkTmpr - wrkOfst;

    if ((signed int)(wrkLastTmpr - wrkTmpr) > 1024 || (signed int)(wrkTmpr - wrkLastTmpr) > 1024)
      wrkReadTemprState = 10;
    wrkLastTmpr = wrkTmpr;
  } else
  
  if (wrkReadTemprState == 9) 
  {
    if (flTUNE_Mode)
      __IntTo4Dec(wrkTmpr, Data_Tempr, 1); else
      __IntTo4Dec(wrkTmpr, Data_Tempr, 0);
  }

  wrkReadTemprState++;  //         
}
/*-------------------------------------------------------------------------------------------*/
void _Inc_Power(void)
{
  if (wrkPower != 150)
    wrkPower++; else
    flSoundOn = 0;//1; 
  Data_Tempr[0] = Data_Tempr[0] | (0x2); 
  return;
}
void _Dec_Power(void)
{
  if (wrkPower != 0)
    wrkPower--; else
    flSoundOn = 0;//1;
  Data_Tempr[0] = Data_Tempr[0] & (~(0x2));
  return;
}
void Compare_Tempr(void)
{
  flCompTempr = 0;
  tmpCmpCount++;
  if (tmpCmpCount != wrkCmpCount) return;
  tmpCmpCount = 0;

  #asm
    movf	_Data_Tempr+TMPR_L_100,w
    subwf	_Data_Tempr+TMPR_100,w
    btfss	STATUS,Z
    goto	NOT_EQUAL_1
    movf	_Data_Tempr+TMPR_L_10,w
    subwf	_Data_Tempr+TMPR_10,w
    btfss	STATUS,Z
    goto	NOT_EQUAL_1
    movf	_Data_Tempr+TMPR_L_1,w
    subwf	_Data_Tempr+TMPR_1,w
    NOT_EQUAL_1:
    btfss	STATUS,C
    call	__Inc_Power
  #endasm

  #asm
    movf	_Data_Tempr+TMPR_100,w
    subwf	_Data_Tempr+TMPR_H_100,w
    btfss	STATUS,Z
    goto	NOT_EQUAL_2
    movf	_Data_Tempr+TMPR_10,w
    subwf	_Data_Tempr+TMPR_H_10,w
    btfss	STATUS,Z
    goto	NOT_EQUAL_2
    movf	_Data_Tempr+TMPR_1,w
    subwf	_Data_Tempr+TMPR_H_1,w
    NOT_EQUAL_2:
    btfss	STATUS,C
    call	__Dec_Power
  #endasm
}
/*-------------------------------------------------------------------------------------------*/
void __IntTo4Dec(int Value, unsigned char *Digits, char Dec001)
{
  Digits[1] = 0;
  Digits[2] = 0;
  Digits[3] = 0;

  //  
  do
  {
    Value = Value - 1000;
    Digits[3]++;
  }
  while (Value > 0);
  if (Value < 0)
  {
    Value = Value + 1000;
    Digits[3]--;
  }
  //  
  do
  {
    Value = Value - 100;
    Digits[2]++; 
  }
  while (Value > 0);
  if (Value < 0)
  {
    Value = Value + 100;
    Digits[2]--;
  }
  //  
  do
  {
    Value = Value - 10;
    Digits[1]++;
  }
  while (Value > 0);
  if (Value < 0)
  {
    Value = Value + 10;
    Digits[1]--;
  }
  //  
  if (Dec001)
  {
    Digits[0] = 0;
    do
    {
      Value = Value - 1;
      Digits[0]++;
    }
    while (Value > 0);
    if (Value < 0)
    {
      Value = Value + 1;
      Digits[0]--;
    }
  }
}
/*-------------------------------------------------------------------------------------------*/
int __Dec4ToInt(unsigned char *Digits)
{
  int Result; 
  unsigned char i;
  Result = 0;
  for (i = 0; i < Digits[3]; i++)
    Result = Result + 1000;
  for (i = 0; i < Digits[2]; i++)
    Result = Result + 100;
  for (i = 0; i < Digits[1]; i++)
    Result = Result + 10;
  for (i = 0; i < Digits[0]; i++)
    Result = Result + 1;
  return Result;
}
/*-------------------------------------------------------------------------------------------*/
void Init_CPU(void)
{
  char i;
  CMCON = 0B00000101; // 0B00000111; 
  
  //  
  TRISA = 0b00100110;
  TRISB = 0b01000000;
  PORTA = 0;
  PORTB = 0;

//  T1CON = 0b00000110; //   1
  
  //   0
  OPTION = 0b11000101;
  T0CS = 0;
  PSA = 0;
  T0IE = 1;
  
  //   2
  T2CON = 0b00000110;
  PR2 = 249;
  TMR2IE = 1;

  //  
  CMCON = CMCON; CMIF = 0; //  
  CMIE = 1;

  //  
  PEIE = 1;
  GIE = 1;

  wrkPower = 75;
  wrkMode = 0;
  wrkDig = 0;
  wrkSetDig = 0;
  wrkZoom = 1000; 
  wrkOfst = 0;

  flSetMode = 0;
  flBtn0 = 1; flBtnSet = 0;  flBtnMode = 0;  flBtnInc = 0;

  for (i = 4; i < 28; i++)
    Data_Tempr[i] = EEPROM_READ(i);
  Data_Tempr[0] = 12; //   

  wrkOfst = EEPROM_READ(29) << 8; 
  wrkOfst = wrkOfst | EEPROM_READ(28);
  wrkZoom = EEPROM_READ(31) << 8; 
  wrkZoom = wrkZoom | EEPROM_READ(30);

  wrkCmpCount = EEPROM_READ(32);
  tmpCmpCount = 0;
}
/*-------------------------------------------------------------------------------------------*/
void Out_Digit(void)
{
  unsigned char iTmp;  char i;

  Out_Sound();

  fl125Hz = 0;
  pinDCSt = 0;
  wrkDig++;
  if (wrkDig == 4)
  {
    wrkDig = 0;
    if (flTUNE_Mode)
      Read_Btns_TUNE(); else
      Read_Btns();
  }
  pinDCSt = 0;

  if (flSetMode)
  {
    if ((wrkDig == wrkSetDig) && (wrkDel_1Hz & 0x80))
    {
      //  
      pinLCD1 = 1;
      pinLCD10 = 1;
      pinLCD100 = 1;
      pinLCD1000 = 1;
      pinDCSt = 1;
      return;
    }
  } 

  iTmp = IntTo7LCD[Data_Tempr[wrkMode + wrkDig]];

  if (wrkDel_1Hz & 0x80) // 
    iTmp |= 0b00000001;

  //    
  pinDCDat = 0;
  for (i = 0; i < 8; i++)
  {
    if (iTmp & 0b10000000)
      pinDCDat = 1; else
      pinDCDat = 0;
    //   
    pinDCClk = 1;
    iTmp = iTmp << 1;
    pinDCClk = 0;
  }
  pinDCDat = 0;
  pinDCClk = 0;

  //  
  pinLCD1 = 1;
  pinLCD10 = 1;
  pinLCD100 = 1;
  pinLCD1000 = 1;
  pinDCSt = 1;
  switch (wrkDig)
  {
    case 0: pinLCD1 = 0; break;
    case 1: pinLCD10 = 0; break;
    case 2: pinLCD100 = 0; break;
    case 3: pinLCD1000 = 0; break;
  }
}
/*-------------------------------------------------------------------------------------------*/
void Read_Btns(void)
{
  wrkBtnIndx++;
  if (wrkBtnIndx == 4)
    wrkBtnIndx = 0;

  if (wrkBtnIndx == 0)
  {
    //   
    pinDCSt = 1;
    if (pinBtns && flBtn0)
    {
      //  
      flBtn0 = 0;
      flBtnMode = 1;
      flSetMode = 1;
      wrkMode = wrkMode >> 2;
      wrkMode++;
      if (wrkMode == 7)
      {
        wrkMode = 0;
        flSetMode = 0;
      }
      wrkMode = wrkMode << 2;
    } else
    if ((!pinBtns) && flBtnMode)
    {
      flBtn0 = 1;
      flBtnMode = 0;
    }
  } else

  if (wrkBtnIndx == 1)
  {
    //   
    pinDCClk = 1;
    if (pinBtns && flBtn0)
    {
      //  
      flBtn0 = 0;
      flBtnSet = 1;

      if (flSetMode)
      {
        wrkSetDig++;
        wrkSetDig = wrkSetDig & 0b00000011;
      } else
      {
        //  \
        if (wrkMode == 0)
          wrkMode = CLOCK_Min1; else
          wrkMode = 0;
      }
    } else
    if ((!pinBtns) && flBtnSet) 
    {
      //  
      flBtn0 = 1;
      flBtnSet = 0;
    }
  } else

  if (wrkBtnIndx == 3)
  {
    //   Inc
    pinDCDat = 1;
    if (pinBtns && flBtn0)
    {
      //  ++
      flBtn0 = 0;
      flBtnInc = 1;
      flSoundOn = 0;
      if (!flSetMode) return;

      Data_Tempr[wrkMode + wrkSetDig]++;
      if (Data_Tempr[wrkMode + wrkSetDig] == 10)
        Data_Tempr[wrkMode + wrkSetDig] = 0;
 
      EEPROM_WRITE(wrkMode + wrkSetDig, Data_Tempr[wrkMode + wrkSetDig]);

      if (wrkMode == DRV_WORK_1)
      {
        tmpDrvWork1 = 0;
        tmpDrvWork10 = 0;
        tmpDrvWork100 = 0;
      } else
      if (wrkMode == DRV_PAUSE_1)
      {
        tmpDrvPause1 = 0;
        tmpDrvPause10 = 0;
        tmpDrvPause100 = 0;
      } 
    } 
    else
    if ((!pinBtns) && flBtnInc)
    {
      //  ++
      flBtn0 = 1;
      flBtnInc = 0;
    }
  }
}
/*-------------------------------------------------------------------------------------------*/
void Read_Btns_TUNE(void)
{
  wrkBtnIndx++;
  if (wrkBtnIndx == 4)
    wrkBtnIndx = 0;

  if (wrkBtnIndx == 0)
  {
    //   
    pinDCSt = 1;
    if (pinBtns && flBtn0)
    {
      //  
      flBtn0 = 0;
      flBtnMode = 1;
      flSetMode = 1;
      wrkMode = wrkMode >> 2;
      wrkMode++;
      if (wrkMode == 4)
      {
        wrkMode = 0;
        flSetMode = 0;
      }
      wrkMode = wrkMode << 2;
    } else
    if ((!pinBtns) && flBtnMode)
    {
      flBtn0 = 1;
      flBtnMode = 0;
    }
  } else

  if (wrkBtnIndx == 1)
  {
    //   
    pinDCClk = 1;
    if (pinBtns && flBtn0)
    {
      //  
      flBtn0 = 0;
      flBtnSet = 1;

      if (flSetMode)
      {
        wrkSetDig++;
        wrkSetDig = wrkSetDig & 0b00000011;
      };
    } else
    if ((!pinBtns) && flBtnSet) 
    {
      //  
      flBtn0 = 1;
      flBtnSet = 0;
    }
  } else

  if (wrkBtnIndx == 3)
  {
    //   Inc
    pinDCDat = 1;
    if (pinBtns && flBtn0)
    {
      //  ++
      flBtn0 = 0;
      flBtnInc = 1;
      flSoundOn = 0;
      if (!flSetMode) return;

      Data_Tempr[wrkMode + wrkSetDig]++;
      if (Data_Tempr[wrkMode + wrkSetDig] == 10)
        Data_Tempr[wrkMode + wrkSetDig] = 0;

      if (wrkMode == 4)  //  
      {
        wrkOfst = __Dec4ToInt(Data_Tempr+4);
        EEPROM_WRITE(28, wrkOfst);
        EEPROM_WRITE(29, wrkOfst >> 8);
        
      } else
      if (wrkMode == 8)  //  
      {
        wrkZoom = __Dec4ToInt(Data_Tempr+8);
        EEPROM_WRITE(30, wrkZoom);
        EEPROM_WRITE(31, wrkZoom >> 8);
      } 
      if (wrkMode == 12)  //   
      {
        wrkCmpCount = __Dec4ToInt(Data_Tempr+12);
        EEPROM_WRITE(32, wrkCmpCount);
      } 
    } 
    else
    if ((!pinBtns) && flBtnInc)
    {
      //  ++
      flBtn0 = 1;
      flBtnInc = 0;
    }
  }
}
/*-------------------------------------------------------------------------------------------*/
void Inc_Clock(void)
{
  flSec = 0;

  wrkTo1Min++;
  if (wrkTo1Min != 60)
    return;

  wrkTo1Min = 0;
  Data_Tempr[CLOCK_Min1]++;

  Compare_Alarm();
  Carry_Clock();
}
/*-------------------------------------------------------------------------------------------*/
void Carry_Clock(void)
{
  //  
  //   
  if (Data_Tempr[CLOCK_Min1] == 10)
  {
    Data_Tempr[CLOCK_Min1] = 0;
    if (flSetMode == 0) Data_Tempr[CLOCK_Min10]++;
  }
  //   
  if (Data_Tempr[CLOCK_Min10] == 6)
  {
    Data_Tempr[CLOCK_Min10] = 0;
    if (flSetMode == 0) 
    {
      Data_Tempr[CLOCK_Hour1]++;
      //   24
      if (Data_Tempr[CLOCK_Hour1] == 4 && Data_Tempr[CLOCK_Hour10] == 2)
      {
        Data_Tempr[CLOCK_Hour1] = 0; Data_Tempr[CLOCK_Hour10] = 0; return;
      }
    }
  }
  //   
  if (Data_Tempr[CLOCK_Hour1] == 10)
  {
    Data_Tempr[CLOCK_Hour1] = 0;
    if (flSetMode == 0) Data_Tempr[CLOCK_Hour10]++;
  }
  //   
  //  clkHour1  
  if ((Data_Tempr[CLOCK_Hour1] & 0b11111100) != 0 && Data_Tempr[CLOCK_Hour10] == 2)
  {
    Data_Tempr[CLOCK_Hour10] = 0; return;
  } 
  //  clkHour1  
  if (Data_Tempr[CLOCK_Hour10] == 3)
  {
    Data_Tempr[CLOCK_Hour10] = 0; return;
  }
}
/*-------------------------------------------------------------------------------------------*/
void Compare_Alarm(void)
{
  if (Data_Tempr[CLOCK_ALARM_1] == Data_Tempr[CLOCK_Min1] && 
   Data_Tempr[CLOCK_ALARM_10] == Data_Tempr[CLOCK_Min10] &&
   Data_Tempr[CLOCK_ALARM_100] == Data_Tempr[CLOCK_Hour1] &&
   Data_Tempr[CLOCK_ALARM_1000] == Data_Tempr[CLOCK_Hour10])
    flSoundOn = 1; else
    flSoundOn = 0;
}
/*-------------------------------------------------------------------------------------------*/
void Out_Sound(void)
{
  if (flSoundOn && (wrkDel_1Hz & 0x20) && (wrkDel_1Hz & 0x80))
    pinSound = 1; else
    pinSound = 0; 
}
/*-------------------------------------------------------------------------------------------*/
char Check_TuneMode()
{
  pinDCSt = 1;
  if (pinBtns == 0)
    return 0;
  pinDCClk = 1;
  if (pinBtns == 0)
    return 0;
  pinDCDat = 1;
  if (pinBtns == 0)
    return 0;
  return 1;
}
/*-------------------------------------------------------------------------------------------*/
void Inc_Timer(void)
{
  if ( Data_Tempr[DRV_WORK_1] == 0 && Data_Tempr[DRV_WORK_10] == 0 && Data_Tempr[DRV_WORK_100] == 0 )
  {
    pinDriver = 0; return;
  }
  if ( Data_Tempr[DRV_PAUSE_1] == 0 && Data_Tempr[DRV_PAUSE_10] == 0 && Data_Tempr[DRV_PAUSE_100] == 0 )
  {
    pinDriver = 1; return;
  }

  if (pinDriver)
  {
    //   
    tmpDrvWork1++;
    if (tmpDrvWork1 == 10) 
    {
      tmpDrvWork1 = 0; tmpDrvWork10++;
      if (tmpDrvWork10 == 10)
      {
        tmpDrvWork10 = 0; tmpDrvWork100++;
        if (tmpDrvWork100 == 10)
        {
          tmpDrvWork100 = 0;
        }
      }
    }
    //   
    if (tmpDrvWork1 == Data_Tempr[DRV_WORK_1] && 
     tmpDrvWork10 == Data_Tempr[DRV_WORK_10] &&
     tmpDrvWork100 == Data_Tempr[DRV_WORK_100])
      {
        tmpDrvWork1 = 0;
        tmpDrvWork10 = 0;
        tmpDrvWork100 = 0;
        pinDriver = 0;
        Data_Tempr[0] = Data_Tempr[0] & (~(0x1));
      }
  } else
  {
    //   
    tmpDrvTo1Min++;
    if (tmpDrvTo1Min != 60) return;
    tmpDrvTo1Min = 0;

    tmpDrvPause1++;
    if (tmpDrvPause1 == 10) 
    {
      tmpDrvPause1 = 0; tmpDrvPause10++;
      if (tmpDrvPause10 == 10)
      {
        tmpDrvPause10 = 0; tmpDrvPause100++;
        if (tmpDrvPause100 == 10)
        {
          tmpDrvPause100 = 0;
        }
      }
    }
    //   
    if (tmpDrvPause1 == Data_Tempr[DRV_PAUSE_1] && 
     tmpDrvPause10 == Data_Tempr[DRV_PAUSE_10] &&
     tmpDrvPause100 == Data_Tempr[DRV_PAUSE_100])
      {
        tmpDrvPause1 = 0;
        tmpDrvPause10 = 0;
        tmpDrvPause100 = 0;
        pinDriver = 1;
        Data_Tempr[0] = Data_Tempr[0] | (0x1);
      }
  }
}
/*-------------------------------------------------------------------------------------------*/
void main(void)
{
  Init_CPU();
  if (Check_TuneMode() == 0)
    flTUNE_Mode = 0; else
    flTUNE_Mode = 1;

//flTUNE_Mode = 1;

  if (!flTUNE_Mode)
  {
    //   
    for (;;)                                                                                
    {
//      if (fl125Hz)
        Out_Digit();
      if (flReadTempr)
        Read_Tempr();
      if (flCompTempr)
        Compare_Tempr();

      if (flSec)
        Inc_Timer();
      if (flSec)
        Inc_Clock();
      if (flSetMode)
        Carry_Clock();
    }
  } else
  {
    //  
    __IntTo4Dec(wrkOfst, Data_Tempr+4, 1);
    __IntTo4Dec(wrkZoom, Data_Tempr+8, 1);
    __IntTo4Dec(wrkCmpCount, Data_Tempr+12, 1);
    for (;;)                                                                                
    {
//      if (fl125Hz)
        Out_Digit();
      if (flReadTempr)
        Read_Tempr();
    }
  }
}




